#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define TEXT_SIZE 32	//一文字のサイズ

//MAC
#include "SDL.h"
#define IMAGE_PASS "fontTest.app/Contents/Resources/fontImg.bmp"	//フォント画像のパス

//WIN
/*#include "SDL/SDL.h"
#define IMAGE_PASS "fontImg.bmp"	//フォント画像のパス
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")	*/

SDL_Surface *mWIN;	//ウィンドウ用
SDL_Surface *iFont;	//フォント画像用

//______________________________________________________________________________ フォントの描画
void fontDraw(Sint16 post_X,	Sint16 post_Y,	char *words,	...)
{
char txt[256];						//引数*words 格納用
char *string;							//txtの変換したのを格納用

va_list ap;								//可変引数の用意
va_start(ap, words);			//初期化
vsprintf(txt, words, ap);	//変換
va_end(ap);								//破棄
string=txt;								//入れ替え

while( *string != '\0' )
	{
	SDL_Rect src,drw;
	src.x = *string*TEXT_SIZE;		//画像の文字位置調節
	src.y = 0;
	src.w = src.h = TEXT_SIZE;	//一文字のサイズ
	drw.x = post_X;							//描画位置
	drw.y = post_Y;
	
	SDL_BlitSurface( iFont, &src, mWIN, &drw );//描画
	
	post_X += TEXT_SIZE;	//描画文字位置調節
	string  += 1;	//次の文字へ
	}
}
//______________________________________________________________________________ メイン関数
int main(int argc, char *argv[])
{
//初期化
if(SDL_Init(SDL_INIT_VIDEO)==-1)	SDL_Quit();

//ウィンドウ作成
mWIN=SDL_SetVideoMode(320,240,16,SDL_SWSURFACE);
SDL_WM_SetCaption("fontTest",NULL);

//フォント読み込み
iFont = SDL_LoadBMP(	IMAGE_PASS	);
if(	!iFont	)	SDL_Quit();

//バック地（薄いグレー）を描画
///SDL_FillRect(mWIN,NULL,SDL_MapRGB(mWIN->format,224,224,224));

//文字の描画
fontDraw(	16,	16,							"TEST:");
fontDraw(	16,	16+TEXT_SIZE,		"CHAR =%c",'A');			//テスト　char型
fontDraw(	16,	16+TEXT_SIZE*2,	"STR  =%s","OK");			//テスト　str型
fontDraw(	16,	16+TEXT_SIZE*3,	"INT  =%d",123);			//テスト　int型
fontDraw(	16,	16+TEXT_SIZE*4,	"FLOAT=%0.1f",0.5f);	//テスト　float型

//画面更新して、５秒経ったら終了
SDL_Flip(mWIN);
SDL_Delay(5000);
SDL_Quit();
return 0;
}
